Program FASTPCX;
uses crt;

VAR
  PCXBUFFER               : Pointer;   { enthlt die gesamte PCXDATEI       }
  PCXFile                 : File;      { Die PCXDatei                       }
  LineBuffer              : Pointer;   { enthlt jeweils eine Zeile         }
  BufPos                  : Word;      { aktuelle Position innerhalb des Puffers}

Procedure DEMOScreen;
Begin
  writeln('Programmers DiskMag        Asgabe 2''94');
  Writeln;
  Writeln('Was jetzt folgt, wird dem mit SLOWPCX an den Rand des Wahnsinns getriebenen');
  Writeln('Speed-Fetischisten ein wenig Balsam auf die blutenden Wunden schmieren. Wir');
  Writeln('haben so ziemlich alle Register gezogen, um die ganze Sache zu beschleunigen.');
  Writeln('Zuerst wird das ganze File in einem Zuge in den RAM geprgelt und dann wird ');
  Writeln('der Assembler auf den Datenwust losgelassen und mit internen Buffern nur so');
  Writeln('hin- und hergeschleudert, aber schauts euch einfach mal an.                 ');
  Writeln;
  Writeln('             Geschrieben in den Katakomben der BSR-SOTWARGroup Sachsen-Anhalt');
  writeln('                    von DJ ByteDisaster');
End;

{---------------------------------------------------------------------------}
{ Die Prozedur PCXFile liest die gesamte Datei BSR.PCX in einem Zuge in den }
{ Puffer PCXBUFFER, dabei wird lediglich der Header weggelassen, denn der   }
{ ist belanglos, da wir die Daten des Bildes kennen.                        }
{ Gleichzeitig wird der Zeilenpuffer so initialisiert, da er alle 4 Bit-   }
{ planeinhalte einer VGA-Zeile aufnehmen kann.                              }
{---------------------------------------------------------------------------}
Procedure ReadPCXFile;
Begin
  Getmem(PCXBuffer,40500);               { Puffer initialisieren            }
  {$I-}                                  { I/O-Checking aus                 }
  Assign(PCXFile,'..\SONSTIGE\BSR.PCX'); { File-Name zuweisen               }
  Reset(PCXFile,1);                      { und Datei ffnen                 }
  If IOResult<>0 Then                    { Fehler beim ffnen ??            }
  Begin                                  { Beginn Fehlerroutine             }
    asm mov ax,0003h;int 10h end;        { Texmodus setzen                  }
    Writeln('Fehler beim ffnen der Datei ..\SONSTIGE\BSR.PCX');
    Writeln('Stellen Sie sicher, da Sie das PDM richtig installiert haben,');
    Writeln('da Sie sich im Verzeichnis PROGS befinden und da die Datei ');
    Writeln('BSR.PCX im verzeichnis SONSTIGE liegt.');
    halt;
  End;
  seek(PCXFile,128);                     { Header bergehen                 }
  BlockRead(PCXFile,PCXBuffer^,40496);       { Datei in einem Abwasch einlesen  }
  close(PCXFile);                        { und Datei schlieen              }
  Getmem(LineBuffer,320);                { Zeilenpuffer initialisieren      }
End;

{---------------------------------------------------------------------------}
{ Die Prozedur DrawLine bertrgt den Inhalt des LineBuffers in eine VGA-   }
{ zeile. Die Prozedur hat den Vorteil, da nicht wie bei SLOWPCX jedes byte }
{ einzeln bertragen wird, sondern die Linie wird erst dargestellt, wenn sie}
{ komplett dekomprimiert ist und dann in einem Zuge                         }
{---------------------------------------------------------------------------}
Procedure DrawLine(LineNr : Word);Assembler;
asm
  push ds                 { DS auf stack schmeien                          }
  mov  ax,LineNr          { Zeilen Nummer nac AX Laden                      }
  mov  bx,0050h           { Multiplikator 80 nach BX laden                  }
  mul  bx                 { AX*BX -> AX enthlkt jetzt die Offset-Adresse der Zeile}
  mov  di,ax              { Offset nach DI bertragen                       }
  mov  ax,0A000h          { AX mit VGA-Segmentadresse laden                 }
  mov  es,ax              { und nach ES bertragen                          }
  segds
  mov  si,word ptr [linebuffer] { SI mit OFFSET der liniendaten laden       }
  segds
  mov  ax,word ptr [linebuffer+02h] {AX mit SEGMENT der liniendaten laden   }
  mov  ds,ax              { und nach DS bertragen                          }
  mov  dx,03C4h           { DX auf port-adresse des Sequencer-Controllers   }
  mov  ax,0102h           { erste Bitplane wollen wir einschalten           }
  out  dx,ax              { pack 'mers                                      }
  mov  cx,0050h           { wir wollen 80 Byte bertragen                   }
  rep  movsb              { tun wir's                                       }
  sub  di,0050h           { DI auf linienanfang zurck                      }
  mov  ax,0202h           { erste Bitplane wollen wir einschalten           }
  out  dx,ax              { pack 'mers                                      }
  mov  cx,0050h           { wir wollen 80 Byte bertragen                   }
  rep  movsb              { tun wir's                                       }
  sub  di,0050h           { DI auf linienanfang zurck                      }
  mov  ax,0402h           { erste Bitplane wollen wir einschalten           }
  out  dx,ax              { pack 'mers                                      }
  mov  cx,0050h           { wir wollen 80 Byte bertragen                   }
  rep  movsb              { tun wir's                                       }
  sub  di,0050h           { DI auf linienanfang zurck                      }
  mov  ax,0802h           { erste Bitplane wollen wir einschalten           }
  out  dx,ax              { pack 'mers                                      }
  mov  cx,0050h           { wir wollen 80 Byte bertragen                   }
  rep  movsb              { tun wir's                                       }
  mov  ax,0F02h           { alle planes wieder einschalten                  }
  out  dx,ax              { OK...                                           }
  POP  ds                 { DS wieder vom Stack holen                       }
End;

{---------------------------------------------------------------------------}
{ Die Prozedur DecodeLine dekomprimiert eine Zeile aus dem Datei-Buffer in  }
{ den LineBuffer.                                                           }
{---------------------------------------------------------------------------}
Procedure DecodeLine;Assembler;
VAR
  Orig_DS               : WORD;          { Das originale Datensegment       }
  BUFF_DS               : WORD;          { Das Segment des DateiBuffers     }
  BposInc               : WORD;          { Anzahl der gelesenen Bytes       }
asm
  mov  ax,0000h                          { AX lschen                       }
  mov  bposinc,ax                        { und in bposinc schreiben         }
  mov  ax,ds                             { originales DS nach AX            }
  mov  orig_ds,ax                        { und in Variablen speichern       }
  segds
  mov  ax,word ptr [linebuffer+02h]      { segment der Zeilendaten nach AX  }
  mov  es,ax                             { und nach ES bertragen           }
  segds
  mov  di,word ptr [linebuffer]          { Offset der zeilendaten nach DI   }
  segds
  mov  si,word ptr [pcxbuffer]           { Offset des FileBuffers nach SI   }
  add  si,bufpos                         { und mit bufferposition addieren  }
  segds
  mov  ax,word ptr [pcxbuffer+02h]       { segment des FileBuffers nach AX  }
  mov  buff_ds,ax                        { in variablen speichern           }
  mov  ds,ax                             { und nach DS bertragen           }
  mov  dl,00h                            { dl=plane-Zhler=0                }
 @NextPlane:                             { Hauptschleife      - BEGINN -    }
  mov  dh,00h                            { dh=x-Zhler=0                    }
 @NextChunk:                             { zeilenschleife     - BEGINN -    }
  lodsb                                  { nchstes Byte aus FileBuffer hol.}
  inc  bposinc                           { Bytezhler aktualisieren         }
  mov  ah,al                             { wir brauchen den wert noch mal   }
  and  al,11000000b                      { die untersten 6 Bits ausblenden  }
  cmp  al,11000000b                      { waren sie gesetzt ??             }
  jne  @SimpleStore                      { keine Kodierungskennung gefuden  }
  mov  cl,ah                             { Den wert nach cl bertragen      }
  and  cl,00111111b                      { und den Wiederholwert ermitteln  }
  sub  ch,ch                             { ch lschen                       }
  add  dh,cl                             { x-Zhler aktualisieren           }
  lodsb                                  { ColorWert holen                  }
  inc  bposinc                           { UND Bytezhler aktualisieren     }
  rep  stosb                             { und in LinienBuffer schreiben    }
  jmp  @TestX                            { zur Testroutine springen         }
 @SimpleStore:                           { Nur Colorwert Speichern          }
  mov  al,ah                             { Wert aus AH Holen                }
  stosb                                  { und in LinienBuffer speichern    }
  inc  dh                                { X-Zhler aktualisieren           }
 @TestX:                                 { X-Testroutine                    }
  cmp  dh,50h                            { ist das Zeilenende erreicht ?    }
  jnge @NextChunk                        { Nchstes Byte, wenn nicht        }
  inc  dl                                { planezhler erhhen              }
 @testPlane:
  cmp  dl,04h                            { sind alle planes bearbeitet ?    }
  jnge @nextplane                        { neue plane, wenn nicht           }
  mov  ax,orig_ds                        { AX mit ursprnglichem DS laden   }
  mov  ds,ax                             { und wieder herstellen            }
  mov  ax,bufpos                         { PufferPosition laden             }
  add  ax,bposinc                        { aktualisieren...                 }
  mov  bufpos,ax                         { und zurckschreiben              }
End;

{---------------------------------------------------------------------------}
{ Die Prozedur DisplayPCX hat sich im Vergleich zu Ihrem Pendant der Datei  }
{ SLOWPCX reichlich verringert.                                             }
{---------------------------------------------------------------------------}
Procedure DisplayPCX;
Var
  yp     : Word;                         { Der ZeilenZhler                 }
Begin
  For yp:=0 to 479 Do
  Begin                                  { Hauptschleife      - BEGINN -    }
    Decodeline;                          { linie dekomprimieren             }
    Drawline(yp);                        { und darstellen                   }
  End;                                   { das war#s schon !                }
End;


var i : Integer;

begin
  DEMOSCREEN;                            { Begrungsbildschirm aufbauen    }
  Repeat Until ReadKey=#13;              { auf ENTER warten                 }
  asm                                    { VGA-Modus 640x480 initialisieren }
    mov  ax,0012h
    int  10h;
  End;
  ReadPCXFile;                           { PCXFile und Puffer laden         }
  DisplayPCX;                            { Darstellungsroutine aufrufen     }
  Repeat Until ReadKey=#13;              { auf ENTER warten                 }
  asm mov ax,0003h;int 10h end;          { Texmodus setzen                  }
End.